#include <Wire.h>// download the library for I2c
byte my_address = 5;
byte recv_data[3];
byte cmd_addr = 48;
byte lo_byte;
byte hi_byte;
byte j = 0;
int pot_val;
unsigned long timer = 0;

void setup() {
  Wire.begin(my_address);//arduino address
  Wire.onRequest(requestEvent); // register event
  Wire.onReceive(receiveEvent); // register event
  pinMode(A0, INPUT);
  pinMode(13, OUTPUT);//Yellow Led
  pinMode(12, OUTPUT);//Red Led
  pinMode(11, OUTPUT);//Green Led
  Serial.begin(9600);
}

void loop() {
  if (!timer) {
    timer = millis();
  }

  if (millis() - timer > 100) { // read A0 evry 100ms

    pot_val = analogRead(A0); //read A0
    timer = 0;//reset timer

  }
  //pot_val is a 2byte data it needs to be separated so that it can be transmitted
  lo_byte = pot_val;//get the lobyte of pot_val
  hi_byte = pot_val >> 8;//get the higher byte of pot_val

}

void requestEvent() {
  Wire.write(48);//data header or command address, it is good to put header of every data.
  Wire.write(hi_byte);//second byte
  Wire.write(lo_byte);// third_byte

}
void receiveEvent() {
  j = 0;
  while (Wire.available()) { // loop through all but the last
    recv_data[j] = Wire.read(); // receive byte as a character
    j++;// print the character
  }
  Serial.print(recv_data[0]); Serial.print(" , ");
  Serial.print(recv_data[1]); Serial.print('\n');
  if (recv_data[0] == 48) { // when the header is 48
    digitalWrite(13, recv_data[1]); // put the data to pin 13
  }
  if (recv_data[0] == 49) { // when header is 49
    digitalWrite(12, recv_data[1]); // // put the data to the pin 12
  }
  if (recv_data[0] == 50) { //when header is 50
    digitalWrite(11, recv_data[1]); // put the data to pin 11
  }
  //recv_data[1] is reserved for hi byte incase you want to transmit data greater than 255
  Serial.print('\n');
}
